<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XVpnGatewayMember StructType
 * @subpackage Structs
 */
class XVpnGatewayMember extends AbstractStructBase
{
    /**
     * The issuerName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - maxLength: 255
     * @var string
     */
    public $issuerName;
    /**
     * The serialNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - maxLength: 50
     * @var string
     */
    public $serialNumber;
    /**
     * Constructor method for XVpnGatewayMember
     * @uses XVpnGatewayMember::setIssuerName()
     * @uses XVpnGatewayMember::setSerialNumber()
     * @param string $issuerName
     * @param string $serialNumber
     */
    public function __construct($issuerName = null, $serialNumber = null)
    {
        $this
            ->setIssuerName($issuerName)
            ->setSerialNumber($serialNumber);
    }
    /**
     * Get issuerName value
     * @return string
     */
    public function getIssuerName()
    {
        return $this->issuerName;
    }
    /**
     * Set issuerName value
     * @param string $issuerName
     * @return XVpnGatewayMember
     */
    public function setIssuerName($issuerName = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($issuerName) && strlen($issuerName) > 255) || (is_array($issuerName) && count($issuerName) > 255)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 255 element(s) or a scalar of 255 character(s) at most, "%d" length given', is_scalar($issuerName) ? strlen($issuerName) : count($issuerName)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($issuerName) && !is_string($issuerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($issuerName)), __LINE__);
        }
        $this->issuerName = $issuerName;
        return $this;
    }
    /**
     * Get serialNumber value
     * @return string
     */
    public function getSerialNumber()
    {
        return $this->serialNumber;
    }
    /**
     * Set serialNumber value
     * @param string $serialNumber
     * @return XVpnGatewayMember
     */
    public function setSerialNumber($serialNumber = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($serialNumber) && strlen($serialNumber) > 50) || (is_array($serialNumber) && count($serialNumber) > 50)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 50 element(s) or a scalar of 50 character(s) at most, "%d" length given', is_scalar($serialNumber) ? strlen($serialNumber) : count($serialNumber)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($serialNumber) && !is_string($serialNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serialNumber)), __LINE__);
        }
        $this->serialNumber = $serialNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return XVpnGatewayMember
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
